Summary:	Trace memory leaks
Name:		perl-Test-LeakTrace
Version:	0.17
Release:	5%{?dist}
License:	GPL+ or Artistic
URL:		https://metacpan.org/release/Test-LeakTrace
Source0:	https://cpan.metacpan.org/modules/by-module/Test/Test-LeakTrace-%{version}.tar.gz

BuildRequires:	gcc make coreutils findutils sed
BuildRequires:	perl-devel perl-generators perl-interpreter perl(ExtUtils::MakeMaker)
# Runtime
BuildRequires:	perl(Exporter) >= 5.57
BuildRequires:	perl(strict) perl(Test::Builder::Module) perl(warnings) perl(XSLoader)
# Test
BuildRequires:	perl(autouse) perl(Class::Struct) perl(constant) perl(Data::Dumper)
BuildRequires:	perl(Test::More) >= 0.62 perl(threads)

# Runtime
%{?perl_default_filter}

%description
Test::LeakTrace provides several functions that trace memory leaks. This module
scans arenas, the memory allocation system, so it can detect any leaked SVs in
given blocks.

Leaked SVs are SVs that are not released after the end of the scope they have
been created. These SVs include global variables and internal caches. For
example, if you call a method in a tracing block, perl might prepare a cache
for the method. Thus, to trace true leaks, no_leaks_ok() and leaks_cmp_ok()
executes a block more than once.


%prep
%autosetup -n Test-LeakTrace-%{version}

chmod -c -x lib/Test/LeakTrace/Script.pm t/lib/foo.pl
sed -i -e 's|^#!perl|#!/usr/bin/perl|' benchmark/*.pl example/*.{pl,t} {t,xt}/*.t
rm xt/05_valgrind.t
sed -i -e '/^xt\/05_valgrind\.t/d' MANIFEST


%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}" NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}


%install
%{make_install}
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} -c %{buildroot}


%check
make test


%files
%doc Changes README benchmark/ example/ t/ xt/
%{perl_vendorarch}/auto/Test/
%{perl_vendorarch}/Test/
%{_mandir}/man3/Test::LeakTrace.3*
%{_mandir}/man3/Test::LeakTrace::JA.3*
%{_mandir}/man3/Test::LeakTrace::Script.3*


%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.17-5
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Aug 17 2023 Xiaojie Chen <jackxjchen@tencent.com> - 0.17-4
- Remove perl(:MODULE_COMPAT) which will be generated by perl-generators >= 1.15

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.17-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.17-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Feb 15 2023 rockerzhu <rockerzhu@tencent.com> - 0.17-1
- Initial build
